function AddBind(%division, %name, %command)
{
	for(%i=0;%i<$remapCount;%i++)
	{
		if($remapDivision[%i] $= %division)
		{
			%foundDiv = 1;
			continue;
		}
		if(%foundDiv && $remapDivision[%i] !$= "")
		{
			%position = %i;
			break;
		}
	}
	if(!%foundDiv)
	{
		error("Division not found: " @ %division);
		return;
	}
	if(!%position)
	{
		$remapName[$remapCount] = %name;
		$remapCmd[$remapCount] = %command;
		$remapCount++;
		return;
	}
	for(%i=$remapCount;%i>%position;%i--)
	{
		$remapDivision[%i] = $remapDivision[%i - 1];
		$remapName[%i] = $remapName[%i - 1];
		$remapCmd[%i] = $remapCmd[%i - 1];
	}
	$remapDivision[%position] = "";
	$remapName[%position] = %name;
	$remapCmd[%position] = %command;
	$remapCount++;
}
exec("./CustomShiftingGui.gui");
if(!$CustomShiftingLoaded)
{
	if(isFile("config/client/customshifting.cs"))
	{
		exec("config/client/customshifting.cs");
		$CustomShiftingLoaded = 1;
		if($CustomShifting::shiftAmount["X"] <= 0)
		{
			$CustomShifting::shiftAmount["X"] = 1;	
		}
		if($CustomShifting::shiftAmount["Y"] <= 0)
		{
			$CustomShifting::shiftAmount["Y"] = 1;	
		}
		if($CustomShifting::shiftAmount["Z"] <= 0)
		{
			$CustomShifting::shiftAmount["Z"] = 1;	
		}
		CustomShiftingGui_x.setText($CustomShifting::shiftAmount["X"]);
		CustomShiftingGui_y.setText($CustomShifting::shiftAmount["Y"]);
		CustomShiftingGui_z.setText($CustomShifting::shiftAmount["Z"]);
	}
	else
	{
		$CustomShifting::shiftAmount["X"] = 1;
		$CustomShifting::shiftAmount["Y"] = 1;
		$CustomShifting::shiftAmount["Z"] = 1;
		CustomShiftingGui_x.setText($CustomShifting::shiftAmount["X"]);
		CustomShiftingGui_y.setText($CustomShifting::shiftAmount["Y"]);
		CustomShiftingGui_z.setText($CustomShifting::shiftAmount["Z"]);
		export("$CustomShifting::*","config/client/customshifting.cs",0);
		$CustomShiftingLoaded = 1;
	}
	$CustomShifting = 0;
}
if(!$CustomShiftingBinded)
{
	AddBind("Building","Custom Shifting GUI","CustomShifting_toggleGUI");
	AddBind("Building","Custom Shifting Toggle","CustomShifting_toggle");
	$CustomShiftingBinded = 1;
}
function CustomShifting_setShiftAmount(%x,%y,%z)
{
	$CustomShifting::shiftAmount["X"] = %x <= 0 ? 1 : mCeil(%x);
	$CustomShifting::shiftAmount["Y"] = %y <= 0 ? 1 : mCeil(%y);
	$CustomShifting::shiftAmount["Z"] = %z <= 0 ? 1 : mCeil(%z);
	CustomShiftingGui_x.setText($CustomShifting::shiftAmount["X"]);
	CustomShiftingGui_y.setText($CustomShifting::shiftAmount["Y"]);
	CustomShiftingGui_z.setText($CustomShifting::shiftAmount["Z"]);
	export("$CustomShifting::*","config/client/customshifting.cs",0);
}
function CustomShifting_toggleGUI(%val)
{
	if(%val)
	{
		switch(CustomShiftingGUI.isAwake())
		{
			case 1:
				canvas.popDialog(CustomShiftingGui);
			case 0:
				canvas.pushDialog(CustomShiftingGui);
		}
	}
}
function CustomShifting_toggle(%val)
{
	if(%val)
	{
		switch($CustomShifting)
		{
			case 1:
				$CustomShifting = 0;
				HUD_SuperShift.setBitmap("base/client/ui/superShift");
				HUD_SuperShift.setVisible(0);
			case 0:
				if($SuperShifting)
				{
					toggleSuperShift(1);
					toggleSuperShift(0);
				}
				$CustomShifting = 1;
				HUD_SuperShift.setBitmap("Add-Ons/Client_CustomShifting/customShift");
				HUD_SuperShift.setVisible(1);
		}
	}
}
package Client_CustomShifting
{
	function repeatBrickLeft(%val)
	{
		if($CustomShifting && $shiftingBrick)
		{
			commandtoserver('shiftbrick',0,$CustomShifting::shiftAmount["Y"]-1,0);
			Parent::repeatBrickLeft(%val);
		}
		else
		{
			Parent::repeatBrickLeft(%val);
		}
	}
	function repeatBrickRight(%val)
	{
		if($CustomShifting && $shiftingBrick)
		{
			commandtoserver('shiftbrick',0,-($CustomShifting::shiftAmount["Y"]-1),0);
			Parent::repeatBrickRight(%val);
		}
		else
		{
			Parent::repeatBrickRight(%val);
		}
	}
	function repeatBrickAway(%val)
	{
		if($CustomShifting && $shiftingBrick)
		{
			commandtoserver('shiftbrick',$CustomShifting::shiftAmount["X"]-1,0,0);
			Parent::repeatBrickAway(%val);
		}
		else
		{
			Parent::repeatBrickAway(%val);
		}
	}
	function repeatBrickTowards(%val)
	{
		if($CustomShifting && $shiftingBrick)
		{
			commandtoserver('shiftbrick',-($CustomShifting::shiftAmount["X"]-1),0,0);
			Parent::repeatBrickTowards(%val);
		}
		else
		{
			Parent::repeatBrickTowards(%val);
		}
	}
	function repeatBrickUp(%val)
	{
		if($CustomShifting && $shiftingBrick)
		{
			commandtoserver('shiftbrick',0,0,($CustomShifting::shiftAmount["Z"]*3)-1);
			Parent::repeatBrickUp(%val);
		}
		else
		{
			Parent::repeatBrickUp(%val);
		}
	}
	function repeatBrickDown(%val)
	{
		if($CustomShifting && $shiftingBrick)
		{
			commandtoserver('shiftbrick',0,0,-(($CustomShifting::shiftAmount["Z"]*3)-1));
			Parent::repeatBrickDown(%val);
		}
		else
		{
			Parent::repeatBrickDown(%val);
		}
	}
	function repeatBrickThirdUp(%val)
	{
		if($CustomShifting && $shiftingBrick)
		{
			commandtoserver('shiftbrick',0,0,$CustomShifting::shiftAmount["Z"]-1);
			Parent::repeatBrickThirdUp(%val);
		}
		else
		{
			Parent::repeatBrickThirdUp(%val);
		}
	}
	function repeatBrickThirdDown(%val)
	{
		if($CustomShifting && $shiftingBrick)
		{
			commandtoserver('shiftbrick',0,0,-($CustomShifting::shiftAmount["Z"]-1));
			Parent::repeatBrickThirdDown(%val);
		}
		else
		{
			Parent::repeatBrickThirdDown(%val);
		}
	}
	function shiftBrickLeft(%val)
	{
		$shiftingBrick = %val;
		if($CustomShifting && %val)
		{
			commandtoserver('shiftbrick',0,$CustomShifting::shiftAmount["Y"]-1,0);
			Parent::shiftBrickLeft(%val);
		}
		else
		{
			Parent::shiftBrickLeft(%val);
		}
	}
	function shiftBrickRight(%val)
	{
		$shiftingBrick = %val;
		if($CustomShifting && %val)
		{
			commandtoserver('shiftbrick',0,-($CustomShifting::shiftAmount["Y"]-1),0);
			Parent::shiftBrickRight(%val);
		}
		else
		{
			Parent::shiftBrickRight(%val);
		}
	}
	function shiftBrickAway(%val)
	{
		$shiftingBrick = %val;
		if($CustomShifting && %val)
		{
			commandtoserver('shiftbrick',$CustomShifting::shiftAmount["X"]-1,0,0);
			Parent::shiftBrickAway(%val);
		}
		else
		{
			Parent::shiftBrickAway(%val);
		}
	}
	function shiftBrickTowards(%val)
	{
		$shiftingBrick = %val;
		if($CustomShifting && %val)
		{
			commandtoserver('shiftbrick',-($CustomShifting::shiftAmount["X"]-1),0,0);
			Parent::shiftBrickTowards(%val);
		}
		else
		{
			Parent::shiftBrickTowards(%val);
		}
	}
	function shiftBrickUp(%val)
	{
		$shiftingBrick = %val;
		if($CustomShifting && %val)
		{
			commandtoserver('shiftbrick',0,0,($CustomShifting::shiftAmount["Z"]*3)-1);
			Parent::shiftBrickUp(%val);
		}
		else
		{
			Parent::shiftBrickUp(%val);
		}
	}
	function shiftBrickDown(%val)
	{
		$shiftingBrick = %val;
		if($CustomShifting && %val)
		{
			commandtoserver('shiftbrick',0,0,-(($CustomShifting::shiftAmount["Z"]*3)-1));
			Parent::shiftBrickDown(%val);
		}
		else
		{
			Parent::shiftBrickDown(%val);
		}
	}
	function shiftBrickThirdUp(%val)
	{
		$shiftingBrick = %val;
		if($CustomShifting && %val)
		{
			commandtoserver('shiftbrick',0,0,$CustomShifting::shiftAmount["Z"]-1);
			Parent::shiftBrickThirdUp(%val);
		}
		else
		{
			Parent::shiftBrickThirdUp(%val);
		}
	}
	function shiftBrickThirdDown(%val)
	{
		$shiftingBrick = %val;
		if($CustomShifting && %val)
		{
			commandtoserver('shiftbrick',0,0,-($CustomShifting::shiftAmount["Z"]-1));
			Parent::shiftBrickThirdDown(%val);
		}
		else
		{
			Parent::shiftBrickThirdDown(%val);
		}
	}
	function toggleSuperShift(%val)
	{
		if($CustomShifting)
		{
			CustomShifting_toggle(1);
		}
		Parent::toggleSuperShift(%val);
	}
};
activatePackage(Client_CustomShifting);